Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util.filter
Class KeyFilter

`java.lang.Object
com.tangosol.util.Base
com.tangosol.util.filter.KeyFilter`

All Implemented Interfaces:
  Filter, EntryFilter, IndexAwareFilter

      public class KeyFilter

extends Base
implements EntryFilter, IndexAwareFilter

EntryFilter which checks whether an entry key belongs to a set.

Note: this filter is not serializable and intended to be used only internally by other composite filters to reduce the remaining key set. <p/> As of Coherence 3.2, an equivalent functionality could be achieved using the `InFilter` as follows:

       new InFilter(new KeyExtractor(IdentityExtractor.INSTANCE), setKeys);

Author:
  cp/gg 2002.11.01

Field Summary
`protected Set` | `m_setKeys` The keys that are evaluated to true by this filter.

Constructor Summary
`KeyFilter(Set setKeys)` Construct a key filter.

Method Summary
`Filter` | `applyIndex(Map mapIndexes, Set setKeys)` Filter remaining keys using a Map of available indexes.
`int` | `calculateEffectiveness(Map mapIndexes, Set setKeys)` Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be.
`boolean` | `evaluate(Object o)` Apply the test to the object.
`boolean` | `evaluateEntry(Map.Entry entry)` Apply the test to a Map Entry.
`Set` | `getKeys()` Get the set of keys that are evaluated to true by this filter.
`String` | `toString()` Return a human-readable description for this Filter.

Field Detail

### m_setKeys

    protected Set m_setKeys

  The keys that are evaluated to true by this filter.

Constructor Detail

### KeyFilter

    public KeyFilter(Set setKeys)

  Construct a key filter.
  Parameters:
    `setKeys` - the keys that this filter will evaluate to true

Method Detail

### evaluate

    public boolean evaluate(Object o)

  Apply the test to the object.
  Specified by:
    `evaluate` in interface `Filter`
  Parameters:
    `o` - the object to test
  Returns:
    true if the test passes, false otherwise

### evaluateEntry

    public boolean evaluateEntry(Map.Entry entry)

  Apply the test to a Map Entry.
  Specified by:
    `evaluateEntry` in interface `EntryFilter`
  Parameters:
    `entry` - the Map Entry to evaluate; never null
  Returns:
    true if the test passes, false otherwise

### calculateEffectiveness

    public int calculateEffectiveness(Map mapIndexes,
                                      Set setKeys)

  Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be. <p/> The returned value is an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys. An operation that requires no more than a single access to the index content (i.e. Equals, NotEquals) has an effectiveness of one. Evaluation of a single entry is assumed to have an effectiveness that depends on the index implementation and is usually measured as a constant number of the single operations. This number is referred to as evaluation cost. <p/> If the effectiveness of a filter evaluates to a number larger than the `keySet.size() * <evaluation cost>` then a user could avoid using the index and iterate through the keySet calling `evaluate` rather then `applyIndex`.
  Specified by:
    `calculateEffectiveness` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the set of keys that will be filtered; read-only
  Returns:
    an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys

### applyIndex

    public Filter applyIndex(Map mapIndexes,
                             Set setKeys)

  Filter remaining keys using a Map of available indexes. <p/> The filter is responsible for removing all keys from the passed set of keys that the applicable indexes can prove should be filtered. If the filter does not fully evaluate the remaining keys using just the index information, it must return a filter (which may be an `EntryFilter`) that can complete the task using an iterating implementation. If, on the other hand, the filter does fully evaluate the remaining keys using just the index information, then it should return null to indicate that no further filtering is necessary.
  Specified by:
    `applyIndex` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the mutable set of keys that remain to be filtered
  Returns:
    a `Filter` object (which may be an `EntryFilter`) that can be used to process the remaining keys, or null if no additional filter processing is necessary

### getKeys

    public Set getKeys()

  Get the set of keys that are evaluated to true by this filter.
  Returns:
    the set of keys

### toString

    public String toString()

  Return a human-readable description for this Filter.
  Returns:
    a String description of the Filter

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.